Subject: RE: [Tsvwg] SCTP: using streams

From: [email-masked]
Date: Wed, 7 Nov 2001 18:53:19 +0200

Hi Denio!

> -----Original Message-----
> From: ext Denio Mariz [mailto:[email-masked]]
> Sent: 07. November 2001 17:07
> To: [email-masked]
> Subject: [Tsvwg] SCTP: using streams
> 
> 
> Hello,
> 
> We know the ability of SCTP to deal with more than one stream 
> in the same
> association.
> But, I'm in doubt about the use of this ability in a real 
> situation. So I
> have two questions.
> 
> Supposing an application A is sending and receiving data 
> to/from another
> application B through an association (in a client/server situation):
> a) In which case this communication would require more than 
> one stream to be
> used ? could you give a scenario ?

	Well... let me think about some of them... Imagine that you have an
HTTP server serving web pages. If I'm the client I just need one stream to
send my HTTP petitions of web pages. However, the server provides html pages
that contains several jpgs, gifs, wavs, and stuff. It can send them through
different streams instead of opening several different TCP connection which
is the normal case nowadays... Maybe you need some more intelligence in both
the server and the client, but then you can handle the whole HTTP
transmission under the same congestion parameters...

	If you have for example a video/audio broadcast server, you might
want to have several streams... I can think of one for the video, another
one for the audio, and another one for some other kind of information
(subtitles?), so you don't suffer from head of line blocking among the
different streams of data... I imagine that it can be done, again, using
several TCP connections as well, but then you can't share that much
information among the established TCP connections, while in SCTP you can...

	And the guys using SCTP in SIGTRAN could tell you more uses... As
far as I know they use some streams for management information, and some
other for some other kind of data... :-/

> b) The initiative for create/use a new stream is taken by the 
> client at the
> time of sending a new message (through the SEND ULP-to-SCTP interface,
> please see 10.1.E in RFC 2960). Am I correct ?

	Well... both sides take part. Every time you establish an SCTP
association you somehow negotiate the quantity of outbound and inbound
streams you want. As the streams are costly at the receiver side, the
procedure is something like "I can offer you X outbound streams (so they
will be inbound for me), and I would like to send you data through Y
different streams (they will be inbound for the other)", and the other tells
you "Ok, I can offer you A outbound streams and I would appreciate having up
to B outbound streams...". I would have min (Y, A) outbound streams (and min
(X, B) inbound streams), and the other will have logically the opposite...

	But once created, they number of streams can't be changes...

	I hope this helps!

	BR Iván Arias Rodríguez 

> Thanks,
> 
> Denio Mariz
> 
> 
> 
> _______________________________________________
> tsvwg mailing list
> [email-masked]
> http://www1.ietf.org/mailman/listinfo/tsvwg
> 

_______________________________________________
tsvwg mailing list
[email-masked]
http://www1.ietf.org/mailman/listinfo/tsvwg